/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo Wifi Smart Home V2.0 Lesson 3-4
 * 
 * tutorial url: https://osoyoo.com/?p=40296
 */
#define BLYNK_PRINT Serial
#include <BlynkSimpleShieldEsp8266.h>
#include <ESP8266_Lib.h>
char auth[] = "0ByWpc50cmOJ5O6OyHMaK4OSHkDvUeI-";//replace this with your Blynk Token
char server_ip[]="192.168.1.81"; // replace this line with your Blynk Server IP address
// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "***";//replace this line with your wifi ssid
char pass[] = "***"; //replace this line with your wifi password
#include <SoftwareSerial.h>
SoftwareSerial EspSerial(A9, A8); // RX, TX
ESP8266 wifi(&EspSerial);

#include <RFID.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

RFID rfid(48,49);   //SDA,RST
bool state=true;
LiquidCrystal_I2C lcd(0x27,16,2);
int servoPin = 9; 
SimpleTimer timer;
BLYNK_WRITE(V8)
{
  int pinValue = param.asInt();
  //switchState = pinValue; // read the pushButton State

 if (pinValue == HIGH)
 {
  for(int i=0;i<50;i++){
    int pulsewidth = (0 * 11) + 500; 
    digitalWrite(servoPin, HIGH);
    delayMicroseconds(pulsewidth);
    digitalWrite(servoPin, LOW); 
    delayMicroseconds(20000 - pulsewidth);
  }
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Hello, guys!");
  delay(1000); //wait for 1000 microseconds

  lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left  corner.
 } 
 else if(pinValue == LOW)
 {
  for(int i=0;i<50;i++){
    int pulsewidth = (110 * 11) + 500; 
    digitalWrite(servoPin, HIGH);   
    delayMicroseconds(pulsewidth); 
    digitalWrite(servoPin, LOW);    
    delayMicroseconds(20000 - pulsewidth);
  }
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Close the door!"); // Print a message to the LCD.
  delay(1000); //wait for 1000 microseconds
  lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left corner.

 }
}

//*****************************rfid****************************

void RFIDSENSOR() {
    Serial.println("RFID START!");
    unsigned char type[MAX_LEN];
    //to find the card
    if (rfid.isCard( )) {
      Serial.println("Find the card!"); 
      // Show card type
      ShowCardType(type);
      //Read card sequence number
      if (rfid.readCardSerial()) {
      Serial.print("The card's number is  : ");
      Serial.print(rfid.serNum[0],HEX);
      Serial.print(rfid.serNum[1],HEX);
      Serial.print(rfid.serNum[2],HEX);
      Serial.print(rfid.serNum[3],HEX);
      Serial.print(rfid.serNum[4],HEX);
      Serial.println(" ");
      ShowUser(rfid.serNum);
    }
    //Select card, return card capacity (lock card, prevent most read), remove the line to read the card continuously
    Serial.println(rfid.selectTag(rfid.serNum));
  }
  rfid.halt();
}
void ShowCardType( unsigned char* type)
{
  Serial.print("Card type: ");
  if(type[0]==0x04&&type[1]==0x00) 
    Serial.println("MFOne-S50");
  else if(type[0]==0x02&&type[1]==0x00)
    Serial.println("MFOne-S70");
  else if(type[0]==0x44&&type[1]==0x00)
    Serial.println("MF-UltraLight");
  else if(type[0]==0x08&&type[1]==0x00)
    Serial.println("MF-Pro");
  else if(type[0]==0x44&&type[1]==0x03)
    Serial.println("MF Desire");
  else
    Serial.println("Unknown");
}

void ShowUser( unsigned char* id)
{
  //32 DA 94 10
  //Overhere, you need to use your own card message!!!
  if( id[0]==0x71 && id[1]==0xBA && id[2]==0x2F && id[3]==0x2E ) {   
   Serial.println("Hello Mary!");
   Blynk.notify("Mary is home!");
   lcd.clear();
   lcd.setCursor(0,0); // set the cursor to column 15, line 0
   lcd.print("HELLO Marry!"); // Print a message to the LCD.
   delay(1000); //wait for 500 microseconds
   lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left  corner.
   lcd.setCursor(0,1); // set the cursor to column 15, line 1
   lcd.print("Welcome home!"); // Print a message to the LCD.
  // delay(1000); //wait for 500 microseconds

   for(int i=0;i<50;i++){
    int pulsewidth = (0 * 11) + 500;
    digitalWrite(servoPin, HIGH);
    delayMicroseconds(pulsewidth);
    digitalWrite(servoPin, LOW);
    delayMicroseconds(20000 - pulsewidth);
  }
    // state=RelayStatus(state);
   delay(3000);
  for(int i=0;i<50;i++){
    int pulsewidth = (110 * 11) + 500;
    digitalWrite(servoPin, HIGH);
    delayMicroseconds(pulsewidth); 
    digitalWrite(servoPin, LOW); 
    delayMicroseconds(20000 - pulsewidth);
  }
  lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left corner.

} 
  
  //75 C0 D0 6
  //Overhere, you need to use your own card message!!!
else if(id[0]==0x2E && id[1]==0x7D && id[2]==0xDB && id[3]==0x2B) {
     Serial.println("Hello David!");
     Blynk.notify("David is home!");
     lcd.clear();
     lcd.setCursor(0,0); // set the cursor to column 15, line 0
     lcd.print("HELLO David!"); // Print a message to the LCD.
     delay(1000); //wait for 500 microseconds
     lcd.setCursor(0,1); // set the cursor to column 15, line 1
     lcd.print("Welcome home!"); // Print a message to the LCD.
     //delay(1000); //wait for 500 microseconds



   for(int i=0;i<50;i++){
    int pulsewidth = (0 * 11) + 500;
    digitalWrite(servoPin, HIGH);
    delayMicroseconds(pulsewidth);
    digitalWrite(servoPin, LOW);
    delayMicroseconds(20000 - pulsewidth);
  }
    Serial.println("Open th door");
    delay(3000);
  for(int i=0;i<50;i++){
    int pulsewidth = (110 * 11) + 500;
    digitalWrite(servoPin, HIGH);
    delayMicroseconds(pulsewidth);
    digitalWrite(servoPin, LOW); 
    delayMicroseconds(20000 - pulsewidth);
  }
    lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left corner.
  }
  else{
    Blynk.notify("Unidentified user is ready to open the door!");
    Serial.println("Hello unkown guy!");
    lcd.clear();
    lcd.setCursor(0,0); // set the cursor to column 15, line 0
    lcd.print("Unknow user!"); // Print a message to the LCD.
    delay(2000); //wait for 2000 microseconds
    lcd.clear(); //Clears the LCD screen and positions the cursor in the upper-left corner.
 } 

}

void setup()
{
  // Debug Serial
  Serial.begin(9600);
  SPI.begin(); 
  pinMode(servoPin, OUTPUT);
  lcd.init(); //initialize the lcd
  lcd.backlight(); //open the backlight 
  rfid.init();
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("start");
  // set the data rate for the SoftwareSerial port
  EspSerial.begin(115200);
  EspSerial.write("AT+UART_DEF=9600,8,1,0,0\r\n");
  EspSerial.write("AT+RST\r\n");
  delay(100);
  EspSerial.begin(9600);
  Blynk.begin(auth, wifi, ssid, pass,server_ip,8080);
 
  timer.setInterval(1000, RFIDSENSOR);
}

void loop()
{
  Blynk.run();
  timer.run();

}
